#include "DistrhoPlugin.hpp"

START_NAMESPACE_DISTRHO

class Limiter : public Plugin
{
public:
	Limiter()
		: Plugin(2, 0, 0)
	{
	}

protected:
	const char *getLabel() const override { return "yaw-brick"; }
	const char *getDescription() const override { return "Sigma Male Limiter"; }
	const char *getMaker() const override { return "yaw-audio"; }
	const char *getHomePage() const override { return "https://yaw.man/plugins/yaw-brick"; }
	const char *getLicense() const override { return "Fuck you pay me"; }
	uint32_t getVersion() const override { return d_version(1, 0, 0); }
	int64_t getUniqueId() const override { return d_cconst('y', 'b', 'r', 'k'); }

	void initParameter(uint32_t index, Parameter &parameter) override
	{
		parameter.hints = kParameterIsAutomatable;
		parameter.ranges.def = 0.5f;
		parameter.ranges.min = 0.0f;
		parameter.ranges.max = 1.0f;
		if( index > 0 ) { 
		  parameter.name = "limit";
		  parameter.symbol = "l";
		  parameter.ranges.max = 2.0f;
		}
		else {
		  parameter.name = "gain";
		  parameter.symbol = "g";
		  parameter.ranges.max = 20.0f;
		}
	}

	void sampleRateChanged(double newRate) override
	{}

	float getParameterValue(uint32_t index) const override
	{
		if( index > 0 ) { return limit; }
		else { return gain; }
	}

	void setParameterValue(uint32_t idx, float val) override
	{
		if( idx > 0 ) { limit = val; }
		else { gain = val; }
	}

	void run(const float **inputs, float **outputs, uint32_t frames) override
	{
		for (int chn = 0; chn < 2; ++chn)
		{
			for( uint32_t i = 0; i < frames; ++i) {

				outputs[chn][i] = limit * (2.f / ( 1.f + expf(-inputs[chn][i] * gain)) - 1.f);
			}
		}
	}

private:
    float limit = 0.f;
	float gain = 0.f;
	DISTRHO_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(Limiter)
};

Plugin *createPlugin()
{
	return new Limiter();
}

END_NAMESPACE_DISTRHO
