#include "DistrhoUI.hpp"
#include "scale.h"
#ifdef DEBUG
#include <format>
#include <optional>
#endif

START_NAMESPACE_DISTRHO

class MouseUI : public UI
{
public:
    explicit MouseUI();

    //void buttonClicked(SubWidget *const widget, int) override;
    void parameterChanged(uint32_t index, float value) override;

    void uiIdle() override;
    bool onMouse(const MouseEvent &ev) override;
    bool onMotion(const MotionEvent &ev) override;
    void onResize(const ResizeEvent &ev) override;
    void onNanoDisplay() override;

private:
    void drawCircle(float x, float y, float z, float p);

    bool record = false;
    float x = 0.f;
    float y = 0.f;
    float vol = 0.f;
    float hz = 55.f;
    Scale scale{440.0};

    DISTRHO_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(MouseUI)
};

END_NAMESPACE_DISTRHO